﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Administración.ServiceReference1;

namespace Administración
{
    public partial class UIAltaNoticia : Form
    {
        private ServiceReference1.Service1Client client; //variable per accedir al servei WCF
        private Oferta oldOferta;

        public UIAltaNoticia(Oferta pOferta)
        {
            InitializeComponent();
            client = new ServiceReference1.Service1Client();//nova instancia del servei WCF
            this.oldOferta = pOferta;
        }

        private void button_cancelar_Click(object sender, EventArgs e)
        {
            this.Dispose();
        }

        private void UIAltaNoticia_Load(object sender, EventArgs e)
        {
            this.dateTimePicker1.Value = DateTime.Now;
            if (this.oldOferta != null)
            {//cas modificar nova oferta
                this.dateTimePicker1.Value = this.oldOferta.Fecha;
                this.textBox_nombre.Text = this.oldOferta.Nombre;
                this.richTextBox_content.Text = this.oldOferta.Contenido;
            }
            
        }

        private void button_guardar_Click(object sender, EventArgs e)
        {
            if((validarDatos() == true) && (this.oldOferta == null))
            {//alta de la noticia
                DateTime dataSelected = DateTime.Parse(this.dateTimePicker1.Text);
                client.AñadirOferta(this.textBox_nombre.Text, this.richTextBox_content.Text, dataSelected);
                this.Dispose();
                
            }
            else if ((validarDatos() == true) && (this.oldOferta != null))
            { //modificar noticia
                DateTime dataSelected = DateTime.Parse(this.dateTimePicker1.Text);
                client.ModificarOferta(this.oldOferta.Id, this.textBox_nombre.Text, this.richTextBox_content.Text, dataSelected);
                this.Dispose();
            }
            else
            {//falten dades
                MessageBox.Show("Faltan Datos. Revise el Título/Contenido", "Alta Noticia", MessageBoxButtons.OK, MessageBoxIcon.Warning);
            }

        }

        private bool validarDatos()
        {
            if ((this.textBox_nombre.Text.Length>0)&&(this.richTextBox_content.Text.Length>0))
            {
                return true;
            }
            else
            {
                return false; }
        }

        
    }
}
