﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Administración.ServiceReference1;

namespace Administración
{
    public partial class UIClientes : Form
    {
        private ServiceReference1.Service1Client client; //variable per accedir al servei WCF
        private List<Cliente> clientes;

        public UIClientes()
        {
            InitializeComponent();
            client = new ServiceReference1.Service1Client();//nova instancia del servei WCF
        }

        private void button_cerrar_Click(object sender, EventArgs e)
        {
            this.Dispose();
        }


        //mètode per carregar els clients de la BBDD a la taula
        private void cargarClientes()
        {
            try
            {
                //netejem la llista per si te dades
                dataGridView_Clientes.ClearSelection();
                //recuperem els plats de la BBDD
                clientes = client.ListarClientes().ToList();
                for (int i = 0; i < clientes.Count(); i++)
                {//Carreguem la llista de plats   
                    dataGridView_Clientes.Rows.Add();
                    dataGridView_Clientes.Rows[i].Cells[0].Value = clientes.ElementAt(i).Nombre;
                    dataGridView_Clientes.Rows[i].Cells[1].Value = clientes.ElementAt(i).Mail;
                    dataGridView_Clientes.Rows[i].Cells[2].Value = clientes.ElementAt(i).Telefono;
                    dataGridView_Clientes.Rows[i].Cells[3].Value = clientes.ElementAt(i).SusMenu;
                    dataGridView_Clientes.Rows[i].Cells[4].Value = clientes.ElementAt(i).SusOfertas;
                }
            }
            catch (NullReferenceException ex)
            {
                MessageBox.Show(ex.Message, "Clientes: " + ex.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            catch (SystemException ex1)
            {
                MessageBox.Show(ex1.Message, "Clientes: " + ex1.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            catch (Exception ex2)
            {
                MessageBox.Show(ex2.Message, "Clientes: " + ex2.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }

        }


        //mètode per carregar els clients de la BBDD que contenen el nom passat per param a la taula
        private void cargarClientesNombre(string pNombre)
        {
            try
            {
                //netejem la llista per si te dades
                dataGridView_Clientes.ClearSelection();
                //recuperem els plats de la BBDD
                clientes = client.ListarClientesNombre(pNombre).ToList();
                for (int i = 0; i < clientes.Count(); i++)
                {//Carreguem la llista de plats   
                    dataGridView_Clientes.Rows.Add();
                    dataGridView_Clientes.Rows[i].Cells[0].Value = clientes.ElementAt(i).Nombre;
                    dataGridView_Clientes.Rows[i].Cells[1].Value = clientes.ElementAt(i).Mail;
                    dataGridView_Clientes.Rows[i].Cells[2].Value = clientes.ElementAt(i).Telefono;
                    dataGridView_Clientes.Rows[i].Cells[3].Value = clientes.ElementAt(i).SusMenu;
                    dataGridView_Clientes.Rows[i].Cells[4].Value = clientes.ElementAt(i).SusOfertas;
                }
            }
            catch (NullReferenceException ex)
            {
                MessageBox.Show(ex.Message, "Clientes: " + ex.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            catch (SystemException ex1)
            {
                MessageBox.Show(ex1.Message, "Clientes: " + ex1.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            catch (Exception ex2)
            {
                MessageBox.Show(ex2.Message, "Clientes: " + ex2.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }

        }

        private void button_VerClientes_Click(object sender, EventArgs e)
        {
            try
            {
                //netejem la taula de files
                dataGridView_Clientes.Rows.Clear();
                //carreguem les dades a la taula
                cargarClientes();
            }
            catch (NullReferenceException ex)
            {
                MessageBox.Show(ex.Message, "Ver Clientes: " + ex.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            catch (SystemException ex1)
            {
                MessageBox.Show(ex1.Message, "Ver Clientes: " + ex1.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            catch (Exception ex2)
            {
                MessageBox.Show(ex2.Message, "Ver Clientes: " + ex2.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            
        }

        private void button_FiltroNombre_Click(object sender, EventArgs e)
        {
            try
            {
                //netejem la taula de files
                dataGridView_Clientes.Rows.Clear();
                //carreguem les dades a la taula
                cargarClientesNombre(this.textBox_filtro.Text);
            }
            catch (NullReferenceException ex)
            {
                MessageBox.Show(ex.Message, "Ver Clientes: " + ex.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            catch (SystemException ex1)
            {
                MessageBox.Show(ex1.Message, "Ver Clientes: " + ex1.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            catch (Exception ex2)
            {
                MessageBox.Show(ex2.Message, "Ver Clientes: " + ex2.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

    }
}
