﻿using System;
using System.Resources;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Net.Mail;
using System.Text;
using System.Windows.Forms;
using Administración.ServiceReference1;

namespace Administración
{
    public partial class UIMenus : Form
    {
        private ServiceReference1.Service1Client client; //variable per accedir al servei WCF
        private List<Administración.ServiceReference1.Menu> menus;
        private List<String> listaDistribucion;

        public UIMenus()
        {
            InitializeComponent();
            client = new ServiceReference1.Service1Client();//nova instancia del servei WCF
        }

        private void button_EliminarMenu_Click(object sender, EventArgs e)
        {
            try
            {
                DialogResult result = MessageBox.Show("Confirme la Eliminación", "Eliminar Menu", MessageBoxButtons.OKCancel, MessageBoxIcon.Question);

                if (result == DialogResult.OK)
                {
                    DataGridViewRow row = this.dataGridView_Menus.CurrentRow; //fila seleccionada
                    int idMenu = Convert.ToInt32(row.Cells[0].Value);
                    client.EliminarMenu(idMenu);
                    this.dataGridView_Menus.Rows.Clear();
                    cargarMenus();
                }
                else if (result == DialogResult.Cancel)
                {
                }

            }
            catch (NullReferenceException ex)
            {
                MessageBox.Show("No se ha seleccionado ningún menú", "Menus: " + ex.Source, MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            catch (SystemException ex1)
            {
                MessageBox.Show(ex1.Message, "Menus: " + ex1.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            catch (Exception ex2)
            {
                MessageBox.Show(ex2.Message, "Menus: " + ex2.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        private void button_NuevoMenu_Click(object sender, EventArgs e)
        {
            this.dataGridView_Menus.Rows.Clear();
            UIAltaMenu f = new UIAltaMenu(null);
            f.ShowDialog();
        }

        private void button_EditarMenu_Click(object sender, EventArgs e)
        {
            try{
            DataGridViewRow row = this.dataGridView_Menus.CurrentRow; //fila seleccionada            
            Administración.ServiceReference1.Menu menuModif = new Administración.ServiceReference1.Menu();
            menuModif.Id = Convert.ToInt32(row.Cells[0].Value);
            menuModif.Nombre = Convert.ToString(row.Cells[1].Value);
            menuModif.Precio = Convert.ToDouble(row.Cells[2].Value);
            menuModif.Fecha = Convert.ToDateTime(row.Cells[3].Value);
            menuModif.MinComensales = Convert.ToInt32(row.Cells[5].Value);
            menuModif.Iva = Convert.ToBoolean(row.Cells[6].Value);
            menuModif.Bebida = Convert.ToBoolean(row.Cells[7].Value);

            this.dataGridView_Menus.Rows.Clear();
            UIAltaMenu f = new UIAltaMenu(menuModif);
            f.ShowDialog();

            }
            catch (NullReferenceException ex)
            {
                MessageBox.Show("No se ha seleccionado ningún menú", "Menus: " + ex.Source, MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            catch (SystemException ex1)
            {
                MessageBox.Show(ex1.Message, "Menus: " + ex1.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            catch (Exception ex2)
            {
                MessageBox.Show(ex2.Message, "Menus: " + ex2.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        private void cargarMenus()
        {
            try
            {
                //netejem la llista per si te dades
                dataGridView_Menus.ClearSelection();
                //recuperem els menus de la BBDD
                menus = client.ListarMenus().ToList();
                for (int i = 0; i < menus.Count(); i++)
                {//Carreguem la llista de plats   
                    dataGridView_Menus.Rows.Add();
                    dataGridView_Menus.Rows[i].Cells[0].Value = menus.ElementAt(i).Id;
                    dataGridView_Menus.Rows[i].Cells[1].Value = menus.ElementAt(i).Nombre;
                    dataGridView_Menus.Rows[i].Cells[2].Value = menus.ElementAt(i).Precio;
                    dataGridView_Menus.Rows[i].Cells[3].Value = menus.ElementAt(i).Fecha;
                    dataGridView_Menus.Rows[i].Cells[4].Value = menus.ElementAt(i).Publicar;
                    dataGridView_Menus.Rows[i].Cells[5].Value = menus.ElementAt(i).MinComensales;
                    dataGridView_Menus.Rows[i].Cells[6].Value = menus.ElementAt(i).Iva;
                    dataGridView_Menus.Rows[i].Cells[7].Value = menus.ElementAt(i).Bebida;
                }
            }
            catch (NullReferenceException ex)
            {
                MessageBox.Show(ex.Message, "Menus: " + ex.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            catch (SystemException ex1)
            {
                MessageBox.Show(ex1.Message, "Menus: " + ex1.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            catch (Exception ex2)
            {
                MessageBox.Show(ex2.Message, "Menus: " + ex2.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        private void UIMenus_Load(object sender, EventArgs e)
        {
            cargarMenus();
        }

        private void dataGridView_Menus_SelectionChanged(object sender, EventArgs e)
        {
            this.button_EditarMenu.Enabled = true;
            this.button_EliminarMenu.Enabled = true;
            this.button_EnviarMenu.Enabled = true;
            this.button_ActualizMenu.Enabled = true;
        }

        private void button_actualizar_Click(object sender, EventArgs e)
        {
            this.dataGridView_Menus.Rows.Clear();
            cargarMenus();
        }

        private void button_ActualizMenu_Click(object sender, EventArgs e)
        {
            try
            {
                DataGridViewRow row = this.dataGridView_Menus.CurrentRow; //fila seleccionada
                int idMenu = Convert.ToInt32(row.Cells[0].Value);
                client.DespublicarMenu();
                client.PublicarMenu(idMenu);
                this.dataGridView_Menus.Rows.Clear();
                cargarMenus();

            }
            catch (NullReferenceException ex)
            {
                MessageBox.Show(ex.Message, "Menus: " + ex.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            catch (SystemException ex1)
            {
                MessageBox.Show(ex1.Message, "Menus: " + ex1.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            catch (Exception ex2)
            {
                MessageBox.Show(ex2.Message, "Menus: " + ex2.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        private void button_Cancelar_Click(object sender, EventArgs e)
        {
            this.Dispose();
        }

        private void button_EnviarMenu_Click(object sender, EventArgs e)
        {
            //recuperem la llista de subscripció
            this.listaDistribucion = client.ListaDistribucionMenus().ToList();

            //compovem que hi ha subscriptors
            if (listaDistribucion.Count > 0)
            {
                    Administración.ServiceReference1.Menu tituloMenu = client.menuWeb();
                    List<String> contenidoMenu = client.imprimirMenu().ToList();

                    StringBuilder sb = new StringBuilder();
                    sb = sb.Append(tituloMenu.Nombre +" - "+tituloMenu.Fecha);
                    sb = sb.Append("\n");
                    sb = sb.Append("Precio: "+ tituloMenu.Precio+ " euros");
                    sb = sb.Append("\n");
                    sb = sb.Append("\n");
                    sb = sb.Append("MENU:");
                    sb = sb.Append("\n");
                    sb = sb.Append("----------------------------");
                    sb = sb.Append("\n");
                    for (int j = 0; j < contenidoMenu.Count(); j++)
                    {//escrivim els plats del menu
                        sb = sb.Append(contenidoMenu.ElementAt(j));
                        sb = sb.Append("\n");
                    }

                    //recuperem les dades del nostre servidor
                    string smtpEmail = Administración.Properties.Resources.eMail;
                    string smtpPw = Administración.Properties.Resources.password;
                    string smtpServer = Administración.Properties.Resources.ServidorSmtp;

                    //creem el missatge de mail
                    MailMessage correo = new MailMessage();
                    correo.From = new MailAddress(smtpEmail);
                
                    for (int i = 0; i < this.listaDistribucion.Count(); i++)
                    {//Carreguem la llista de mails dels subscriptors 
                        correo.To.Add(listaDistribucion.ElementAt(i).ToString());
                    }
                    correo.Subject = "Menú UOC Restaurant";

                    correo.Body = sb.ToString();
                    correo.IsBodyHtml = false;
                    correo.Priority = MailPriority.Normal;
                    SmtpClient smtp = new SmtpClient(smtpServer);
                    smtp.EnableSsl = true;
                    smtp.UseDefaultCredentials = false;
                    smtp.Port = 25;
                    smtp.Credentials = new System.Net.NetworkCredential(smtpEmail, smtpPw);

                    try
                    {//enviem el missatge
                        smtp.Send(correo);
                        MessageBox.Show("Envio realizado con éxito", "Enviar Menú", MessageBoxButtons.OK, MessageBoxIcon.Information);
                    }
                    catch (Exception ex)
                    {
                        MessageBox.Show(ex.Message, "Enviar Menú: " + ex.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
                    }
                    }
           
            else
            {
                MessageBox.Show("Sin suscriptores", "Enviar Menú: ", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            }
    }
}
