﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Administración.ServiceReference1;

namespace Administración
{
    public partial class UIMesas : Form
    {
        private ServiceReference1.Service1Client client; //variable per accedir al servei WCF           
        private List<Mesa> mesas;

        public UIMesas()
        {
            InitializeComponent();
            client = new ServiceReference1.Service1Client();//nova instancia del servei WCF
        }

        private void button_Cancelar_Click(object sender, EventArgs e)
        {
            this.Dispose();//tancar la finestra
        }

        private void button_NuevaMesa_Click(object sender, EventArgs e)
        {
            if (validarDatos()==true)
            {
                try 
                {
                    //fem l'alta de la nova taula
                    client.AltaMesa(int.Parse(this.textBox_nuevaMesa.Text), int.Parse(this.textBox_capacidad.Text));
                    dataGridView_Mesas.Rows.Clear();//netejem la taula
                    cargarListaMesas();//actualitzem la taula
                }
                catch (NullReferenceException ex)
                {
                    MessageBox.Show(ex.Message, "Nueva Mesa: " + ex.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
                catch (SystemException ex1)
                {
                    MessageBox.Show(ex1.Message, "Nueva Mesa: " + ex1.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
                catch (Exception ex2)
                {
                    MessageBox.Show(ex2.Message, "Nueva Mesa: " + ex2.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
                }

            }

            
        }
            

        private void cargarListaMesas()
        {
            try
            {
                //netejem la llista per si te dades
                dataGridView_Mesas.ClearSelection();
                //recuperem les taules de la BBDD
                mesas = client.ListarMesas().ToList();
                for (int i = 0; i < mesas.Count(); i++)
                {//Carreguem la llista de taules                                      
                    dataGridView_Mesas.Rows.Add();
                    dataGridView_Mesas.Rows[i].Cells[0].Value = mesas.ElementAt(i).numero;
                    dataGridView_Mesas.Rows[i].Cells[1].Value = mesas.ElementAt(i).comensales;

                }
            }
            catch (NullReferenceException ex)
            {
                MessageBox.Show(ex.Message, "Mesas: " + ex.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            catch (SystemException ex1)
            {
                MessageBox.Show(ex1.Message, "Mesas: " + ex1.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            catch (Exception ex2)
            {
                MessageBox.Show(ex2.Message, "Mesas: " + ex2.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        
        private void UIMesas_Load(object sender, EventArgs e)
        {//al carregar la finestra es carrega la llista de taules
            dataGridView_Mesas.Rows.Clear();//netejem la taula
            cargarListaMesas();
            this.textBox_nuevaMesa.Focus();
        }

       
        private void textBox_nuevaMesa_TextChanged(object sender, EventArgs e)
        {
            try
            {
                int.Parse(textBox_nuevaMesa.Text);
            }
            catch
            {
                this.label6.Visible = true;
                this.textBox_nuevaMesa.Clear();
                this.textBox_nuevaMesa.Focus();
            }
        }

        private void textBox_capacidad_TextChanged(object sender, EventArgs e)
        {
            try
            {
                int.Parse(textBox_capacidad.Text);
            }
            catch
            {
                this.label7.Visible = true;
                this.textBox_capacidad.Clear();
                this.textBox_capacidad.Focus();
            }
        }



        private bool validarDatos()
        {
            bool datos = false;

            if ((this.textBox_nuevaMesa.Text == "") || (this.textBox_capacidad.Text == ""))
            {//valida que s'ha entrat un nº de taula i una capacitat 
                MessageBox.Show("Faltan Datos. Debe ingresar nº de mesa y capacidad", "Error", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                this.textBox_nuevaMesa.Focus();
                return datos;
            }
            else
            {
                if (client.BuscarMesa(int.Parse(this.textBox_nuevaMesa.Text)) == true)
                {//valida que el nº de taula informat és nou
                    MessageBox.Show("El nº de mesa ya existe", "Error", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                    this.textBox_nuevaMesa.Focus();
                    return datos;
                }
                else { datos = true;
                return datos;
                }
            }
        }

        private void textBox_nuevaMesa_Leave(object sender, EventArgs e)
        {
            this.label6.Visible = false;
        }

        private void textBox_capacidad_Leave(object sender, EventArgs e)
        {
            this.label7.Visible = false;
        }

       

  

    }
}
