﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Administración.ServiceReference1;

namespace Administración
{
    public partial class UIPlatos : Form
    {
        private ServiceReference1.Service1Client client; //variable per accedir al servei WCF
        private List<Plato> platos;
        private List<Seccion> secciones;        

        public UIPlatos()
        {
            InitializeComponent();
            client = new ServiceReference1.Service1Client();//nova instancia del servei WCF
        }

       
        private void button_NuevoPlato_Click(object sender, EventArgs e)
        {
            //netejem la taula de files
            dataGridView_Platos.Rows.Clear();

            //creem una nova instància de la finestra 'alta plat' amb la llista de seccions
            UIAltaPlato f = new UIAltaPlato(null, secciones, null);
            f.ShowDialog();
        }

        private void button_Cancelar_Click(object sender, EventArgs e)
        {
            this.Dispose();
        }

        private void buttonModificarPlato_Click(object sender, EventArgs e)
        {
            int numFilas = this.dataGridView_Platos.RowCount;
                if (numFilas > 0)//comprovem que s'ha sel.leccionat algún plat
                {
                    //recuperem el plat seleccionat
                    DataGridViewRow row = this.dataGridView_Platos.CurrentRow;
                    
                    Plato platoModif = new Plato();
                    platoModif.Seccion = Convert.ToInt32(row.Cells[0].Value);
                    platoModif.Id = Convert.ToInt32(row.Cells[2].Value);
                    platoModif.Idioma1 = Convert.ToString(row.Cells[3].Value);
                    platoModif.Precio = float.Parse(Convert.ToString(row.Cells[4].Value));
                    platoModif.Disponible = Convert.ToBoolean(row.Cells[5].Value);
                    platoModif.Iva = Convert.ToBoolean(row.Cells[6].Value);
                    platoModif.MinComensales = Convert.ToInt32(row.Cells[7].Value);
                    platoModif.Idioma2 = Convert.ToString(row.Cells[8].Value);
                    platoModif.Idioma3 = Convert.ToString(row.Cells[9].Value);

                    //netejem la taula de files
                    dataGridView_Platos.Rows.Clear();

                    String nomSecc = Convert.ToString(row.Cells[1].Value);
                    UIAltaPlato f = new UIAltaPlato(platoModif, secciones, nomSecc);
                    f.ShowDialog();

                }
                else 
                {
                    MessageBox.Show("No se ha seleccionado ningún plato", "Modificar Plato", MessageBoxButtons.OK, MessageBoxIcon.Information);
                }
           
        }

        private void button_EliminarPlato_Click(object sender, EventArgs e)
        {
            int numFilas = this.dataGridView_Platos.RowCount;
            if (numFilas > 0)//comprovem que s'ha sel.leccionat algún plat
            {
                try
                {
                    //recuperem el plat seleccionat
                    DataGridViewRow row = this.dataGridView_Platos.CurrentRow;
                    int platoEliminar = Convert.ToInt32(row.Cells[2].Value);
                    //comprobem el plat no està assignat a cap menu o carta
                    if (client.BuscarPlatoEnMenuCarta(platoEliminar) == true)
                    {
                        MessageBox.Show("El plato no se puede eliminar. Está asignado a Menú ó Carta", "Eliminar Plato", MessageBoxButtons.OK, MessageBoxIcon.Information);
                    }
                    else
                    {
                        DialogResult result = MessageBox.Show("Confirme la Eliminación", "Eliminar Plato", MessageBoxButtons.OKCancel, MessageBoxIcon.Question);

                        if (result == DialogResult.OK)
                        {
                            client.EliminarPlato(platoEliminar);
                            //netejem la taula de files
                            dataGridView_Platos.Rows.Clear();
                            //actualitzem les dades a la taula
                            cargarPlatos();
                        }
                    }

                }
                catch (NullReferenceException ex)
                {
                    MessageBox.Show(ex.Message, "Platos: " + ex.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
                catch (SystemException ex1)
                {
                    MessageBox.Show(ex1.Message, "Platos: " + ex1.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
                catch (Exception ex2)
                {
                    MessageBox.Show(ex2.Message, "Platos: " + ex2.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }
            else
            {
                MessageBox.Show("No se ha seleccionado ningún plato", "Eliminar Plato", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }

        }

        protected void cargarPlatos()
        {
             try
            {
                //netejem la llista per si te dades
                dataGridView_Platos.ClearSelection();
                //recuperem els plats de la BBDD
                platos = client.ListarPlatos().ToList();
                for (int i = 0; i < platos.Count(); i++)
                {//Carreguem la llista de plats   
                    dataGridView_Platos.Rows.Add();
                    dataGridView_Platos.Rows[i].Cells[0].Value = platos.ElementAt(i).Seccion;//columna oculta
                    int s = platos.ElementAt(i).Seccion;
                    dataGridView_Platos.Rows[i].Cells[1].Value = client.nombreSeccion(s);
                    dataGridView_Platos.Rows[i].Cells[2].Value = platos.ElementAt(i).Id;
                    dataGridView_Platos.Rows[i].Cells[3].Value = platos.ElementAt(i).Idioma1;
                    dataGridView_Platos.Rows[i].Cells[4].Value = platos.ElementAt(i).Precio;
                    dataGridView_Platos.Rows[i].Cells[5].Value = platos.ElementAt(i).Disponible;
                    dataGridView_Platos.Rows[i].Cells[6].Value = platos.ElementAt(i).Iva;
                    dataGridView_Platos.Rows[i].Cells[7].Value = platos.ElementAt(i).MinComensales;
                    dataGridView_Platos.Rows[i].Cells[8].Value = platos.ElementAt(i).Idioma2;
                    dataGridView_Platos.Rows[i].Cells[9].Value = platos.ElementAt(i).Idioma3;
                }
            }
            catch (NullReferenceException ex)
            {
                MessageBox.Show(ex.Message, "Platos: " + ex.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            catch (SystemException ex1)
            {
                MessageBox.Show(ex1.Message, "Platos: " + ex1.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            catch (Exception ex2)
            {
                MessageBox.Show(ex2.Message, "Platos: " + ex2.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
          }

        private void cargarPlatosSeccion(int seccion)
        {
            try
            {
                //netejem la llista per si te dades
                dataGridView_Platos.ClearSelection();
                //recuperem els plats de la BBDD
                platos = client.ListarPlatosSeccion(seccion).ToList();
                for (int i = 0; i < platos.Count(); i++)
                {//Carreguem la llista de plats   
                    dataGridView_Platos.Rows.Add();
                   
                    dataGridView_Platos.Rows[i].Cells[0].Value = platos.ElementAt(i).Seccion;
                    int s = platos.ElementAt(i).Seccion; 
                    dataGridView_Platos.Rows[i].Cells[1].Value = client.nombreSeccion(s);
                    dataGridView_Platos.Rows[i].Cells[2].Value = platos.ElementAt(i).Id;
                    dataGridView_Platos.Rows[i].Cells[3].Value = platos.ElementAt(i).Idioma1;
                    dataGridView_Platos.Rows[i].Cells[4].Value = platos.ElementAt(i).Precio;
                    dataGridView_Platos.Rows[i].Cells[5].Value = platos.ElementAt(i).Disponible;
                    dataGridView_Platos.Rows[i].Cells[6].Value = platos.ElementAt(i).Iva;
                    dataGridView_Platos.Rows[i].Cells[7].Value = platos.ElementAt(i).MinComensales;
                    dataGridView_Platos.Rows[i].Cells[8].Value = platos.ElementAt(i).Idioma2;
                    dataGridView_Platos.Rows[i].Cells[9].Value = platos.ElementAt(i).Idioma3;
                }
            }
            catch (NullReferenceException ex)
            {
                MessageBox.Show(ex.Message, "Platos: " + ex.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            catch (SystemException ex1)
            {
                MessageBox.Show(ex1.Message, "Platos: " + ex1.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            catch (Exception ex2)
            {
                MessageBox.Show(ex2.Message, "Platos: " + ex2.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        //mètode per carregar els plats de la BBDD a la taula de plats
        private void cargarPlatosNombre(string nombre)
        {
            try
            {
                //netejem la llista per si te dades
                dataGridView_Platos.ClearSelection();
                //recuperem els plats de la BBDD
                platos = client.ListarPlatosNombre(nombre).ToList();
                for (int i = 0; i < platos.Count(); i++)
                {//Carreguem la llista de plats   
                    dataGridView_Platos.Rows.Add();
                    dataGridView_Platos.Rows[i].Cells[0].Value = platos.ElementAt(i).Seccion;
                    int s = platos.ElementAt(i).Seccion;
                    dataGridView_Platos.Rows[i].Cells[1].Value = client.nombreSeccion(s);
                    dataGridView_Platos.Rows[i].Cells[2].Value = platos.ElementAt(i).Id;
                    dataGridView_Platos.Rows[i].Cells[3].Value = platos.ElementAt(i).Idioma1;
                    dataGridView_Platos.Rows[i].Cells[4].Value = platos.ElementAt(i).Precio;
                    dataGridView_Platos.Rows[i].Cells[5].Value = platos.ElementAt(i).Disponible;
                    dataGridView_Platos.Rows[i].Cells[6].Value = platos.ElementAt(i).Iva;
                    dataGridView_Platos.Rows[i].Cells[7].Value = platos.ElementAt(i).MinComensales;
                    dataGridView_Platos.Rows[i].Cells[8].Value = platos.ElementAt(i).Idioma2;
                    dataGridView_Platos.Rows[i].Cells[9].Value = platos.ElementAt(i).Idioma3;
                }
            }
            catch (NullReferenceException ex)
            {
                MessageBox.Show(ex.Message, "Platos: " + ex.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            catch (SystemException ex1)
            {
                MessageBox.Show(ex1.Message, "Platos: " + ex1.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            catch (Exception ex2)
            {
                MessageBox.Show(ex2.Message, "Platos: " + ex2.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        private void cargarComboSecciones()
        {
            try
            {
                //netejem la llista per si te dades
                comboBox_Seccion.Items.Clear();
                //recuperem les seccions de la BBDD
                secciones = client.ListarSecciones().ToList();
                for (int i = 0; i < secciones.Count(); i++)
                {//Carreguem el combo de seccions   
                    comboBox_Seccion.Items.Add(secciones.ElementAt(i).nombre);                    
                }
            }
            catch (NullReferenceException ex)
            {
                MessageBox.Show(ex.Message, "Secciones: " + ex.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            catch (SystemException ex1)
            {
                MessageBox.Show(ex1.Message, "Secciones: " + ex1.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            catch (Exception ex2)
            {
                MessageBox.Show(ex2.Message, "Secciones: " + ex2.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        private void UIPlatos_Load(object sender, EventArgs e)
        {
            cargarComboSecciones();
        }

        private void button_VerPlatos_Click(object sender, EventArgs e)
        {
            try
            {
                //netejem la taula de files
            dataGridView_Platos.Rows.Clear();
            //carreguem les dades a la taula
            cargarPlatos();
            
            }
            catch (NullReferenceException ex)
            {
                MessageBox.Show(ex.Message, "Ver Platos: " + ex.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);                
            }
            catch (SystemException ex1)
            {
                MessageBox.Show(ex1.Message, "Ver Platos: " + ex1.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);               
            }
            catch (Exception ex2)
            {
                MessageBox.Show(ex2.Message, "Ver Platos: " + ex2.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);              
            }
            
        }

        private void button_FiltroSeccion_Click(object sender, EventArgs e)
        {
            try
            {
                if (comboBox_Seccion.SelectedIndex <0)
                {
                    MessageBox.Show("No se ha seleccionado ninguna sección", "Ver Platos: " , MessageBoxButtons.OK, MessageBoxIcon.Warning);
                }
                else
                {
                    //recuperem l'element seleccionat del combobox
                    int item = comboBox_Seccion.SelectedIndex;
                    int filtroSeccion = secciones.ElementAt(item).Id;
                    //netejem la taula de files
                    dataGridView_Platos.Rows.Clear();
                    //carreguem les dades a la taula
                    cargarPlatosSeccion(filtroSeccion);
                }
                
            }
            catch (NullReferenceException ex)
            {
                MessageBox.Show(ex.Message, "Ver Platos: " + ex.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            catch (SystemException ex1)
            {
                MessageBox.Show(ex1.Message, "Ver Platos: " + ex1.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            catch (Exception ex2)
            {
                MessageBox.Show(ex2.Message, "Ver Platos: " + ex2.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        private void button_FiltroNombre_Click(object sender, EventArgs e)
        {
            try
            {
                //netejem la taula de files
                dataGridView_Platos.Rows.Clear();
                //carreguem les dades a la taula
                cargarPlatosNombre(textBox_filtroNombre.Text);
                
            }
            catch (NullReferenceException ex)
            {
                MessageBox.Show(ex.Message, "Ver Platos: " + ex.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            catch (SystemException ex1)
            {
                MessageBox.Show(ex1.Message, "Ver Platos: " + ex1.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            catch (Exception ex2)
            {
                MessageBox.Show(ex2.Message, "Ver Platos: " + ex2.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        private void dataGridView_Platos_SelectionChanged(object sender, EventArgs e)
        {
            button_EliminarPlato.Enabled = true;
            buttonModificarPlato.Enabled = true;

        }

       
       
    }
}
