﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Administración.ServiceReference1;

namespace Administración
{
    public partial class UITurnos : Form
    {
        private ServiceReference1.Service1Client client; //variable per accedir al servei WCF                      
        private List<Turno> turnos;

        public UITurnos()
        {
            InitializeComponent();
            client = new ServiceReference1.Service1Client();//nova instancia del servei WCF
        }

       
        private void cargarListaTurnos()
        {
            try
            {
                //netejem la llista per si te dades
                listBox_Turnos.Items.Clear();
                //recuperem els torns de la BBDD
                turnos = client.ListarTurnos().ToList();
                for (int i = 0; i < turnos.Count(); i++)
                {//Carreguem la llista de taules
                    listBox_Turnos.Items.Add(turnos.ElementAt(i).Hora.ToString());
                }
            }
            catch (NullReferenceException ex)
            {
                MessageBox.Show(ex.Message, "Turnos: " + ex.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            catch (SystemException ex1)
            {
                MessageBox.Show(ex1.Message, "Turnos: " + ex1.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            catch (Exception ex2)
            {
                MessageBox.Show(ex2.Message, "Turnos: " + ex2.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            
        }

        private void button_Cancelar_Click(object sender, EventArgs e)
        {
            this.Dispose();
        }

        private void UITurnos_Load(object sender, EventArgs e)
        {        
            cargarListaTurnos();
            this.maskedTextBox_nuevoTurno.Focus();
            
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (validarDatos() == true)
            {                
                try
                {
                    client.AltaTurno(maskedTextBox_nuevoTurno.Text);//alta del nou torn
                    cargarListaTurnos(); //actualitzar la llista de torns
                }

                catch (NullReferenceException ex)
                {
                    MessageBox.Show(ex.Message, "Alta Turnos: " + ex.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
                catch (SystemException ex1)
                {
                    MessageBox.Show(ex1.Message, "Alta Turnos: " + ex1.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
                catch (Exception ex2)
                {
                    MessageBox.Show(ex2.Message, "Alta Turnos: " + ex2.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }
        }

       

        private bool validarDatos()
        {
            bool datos = false;

            try
            {
                DateTime.Parse(maskedTextBox_nuevoTurno.Text);
              
                if (client.BuscarTurno((maskedTextBox_nuevoTurno.Text)) == true)
                {//validar que l'hora informada és nova
                    MessageBox.Show("El turno informado ya existe", "Error", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                    this.maskedTextBox_nuevoTurno.Focus();
                    return datos;
                }
                else
                {
                    datos = true;
                    return datos;
                }
            }
            catch
            {
                MessageBox.Show("la hora introducida no es correcta", "Alta Turno", MessageBoxButtons.OK, MessageBoxIcon.Error);
                this.maskedTextBox_nuevoTurno.Clear();
                this.maskedTextBox_nuevoTurno.Focus();
                return datos;
            }
        }

        
    }
}
