﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using SitioWeb.ServiceReference1;

namespace SitioWeb.Account
{
    public partial class ModifCuenta : System.Web.UI.Page
    {
        private ServiceReference1.Service1Client client; //variable per accedir al servei WCF
        private Cliente usuario;

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {//codi que s'executa la 1ª vegada que es carrega la pàg
                client = new ServiceReference1.Service1Client();//nova instancia del servei WCF
                usuario = (Cliente)Session["Usuario"];
                if (usuario != null)
                {
                    cargarDatosUsuario();

                }

            }
            else
            {//codi que s'executa cada vegada que es carrega la pàg
                client = new ServiceReference1.Service1Client();//nova instancia del servei WCF
                usuario = (Cliente)Session["Usuario"];
            }
            
            
        }

        protected void cargarDatosUsuario()
        {
            UserId.Text = usuario.Id.ToString();
            UserName.Text = usuario.Nombre;
            Email.Text = usuario.Mail;
            Telefono.Text = usuario.Telefono;
            CheckBox_menu.Checked = usuario.SusMenu.Value;
            CheckBox_noticias.Checked = usuario.SusOfertas.Value;
        }

        protected void CreateUserButton_Click(object sender, EventArgs e)
        {
            //modificació de les dades de client
               client.ModificarCliente(usuario.Id, UserName.Text, Email.Text, usuario.Password, Telefono.Text, CheckBox_menu.Checked, CheckBox_noticias.Checked);
               
            //actualitzem el client
               Cliente clienteLog = client.BuscarCliente(usuario.Mail, usuario.Password);
               Session["Usuario"] = clienteLog;
               usuario = (Cliente)Session["Usuario"];
               
               
               Response.Redirect("~/MiCuenta.aspx");//actualitzem la pàgina
               OkMessage.Text = "Datos modificados satisfactoriamente.";
           
        }

        protected void Email_TextChanged(object sender, EventArgs e)
        {
            //validem que l'username (mail) és nou
            if (client.buscarUsername(Email.Text) == true )
            {

                ErrorMessage.Text = "El Email introducido ya existe para otro usuario";
                //recuperem el mail antic
                Email.Text = usuario.Mail;
            }
            
        }

        
      
        
    }
}