﻿using System;
using System.Resources;
using System.Collections.Generic;
using System.Linq;
using System.Net.Mail;
using System.Text;
using System.Web;
using System.Web.Security;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using SitioWeb.ServiceReference1;

namespace SitioWeb.Account
{
    public partial class Registro : System.Web.UI.Page
    {
        private ServiceReference1.Service1Client client; //variable per accedir al servei WCF
        private Cliente usuario;
        private string url;

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {//codi que s'executa la 1ª vegada que es carrega la pàg
                client = new ServiceReference1.Service1Client();//nova instancia del servei WCF
                usuario = (Cliente)Session["Usuario"];
                url = (String)Session["url"];

            }
            else
            {//codi que s'executa cada vegada que es carrega la pàg
                client = new ServiceReference1.Service1Client();//nova instancia del servei WCF
                usuario = (Cliente)Session["Usuario"];
                url = (String)Session["url"];
            }
            
        }

        protected void CreateUserButton_Click(object sender, EventArgs e)
        {
            //validem que l'username (mail) és nou
            if (client.buscarUsername(Email.Text) == false)
            {
                Cliente nuevoCliente = client.AltaCliente(UserName.Text, Email.Text, Password.Text, Telefono.Text, CheckBox_menu.Checked, CheckBox_noticias.Checked);
               
               //actualitzem la variable de sessió
               Session["Usuario"] = nuevoCliente;

                //enviem el mail de confirmació
               //recuperem les dades del nostre servidor
               string smtpEmail = SitioWeb.Resources.eMail;
               string smtpPw = SitioWeb.Resources.password;
               string smtpServer = SitioWeb.Resources.ServidorSmtp;

               //creem el missatge de mail
               MailMessage correo = new MailMessage();
               correo.From = new MailAddress(smtpEmail);
               correo.To.Add(nuevoCliente.Mail);
               correo.Subject = "Confirmación Reserva, UOC Restaurant";

               StringBuilder sb = new StringBuilder();
               sb = sb.Append("Confirmación de Alta de Usuario en Uoc Restaurant:");
               sb = sb.Append("\n");
               sb = sb.Append("Su nº de cliente: " + nuevoCliente.Id);
               sb = sb.Append("\n");
               sb = sb.Append("su nombre: " + nuevoCliente.Nombre);
               sb = sb.Append("\n");
               sb = sb.Append("username: " + nuevoCliente.Mail);
               sb = sb.Append("\n");
               sb = sb.Append("password: " + nuevoCliente.Password);
               sb = sb.Append("\n" + "\n");
               sb = sb.Append("UOC Restaurant");

               correo.Body = sb.ToString();
               correo.IsBodyHtml = false;
               correo.Priority = MailPriority.Normal;
               SmtpClient smtp = new SmtpClient(smtpServer);
               smtp.EnableSsl = true;
               smtp.UseDefaultCredentials = false;
               smtp.Port = 25;
               smtp.Credentials = new System.Net.NetworkCredential(smtpEmail, smtpPw);

               try
               {//enviem el missatge
                   smtp.Send(correo);
               }
               catch (Exception ex)
               {
                   ErrorMessage.Text = ex.ToString();
               }

                //tornem a reserves si hem vingut d'allà
               if (url != null && url == "~/Reservas.aspx")
               {//si venim de reserves hem de tornar a reserves
                   Response.Redirect("~/Reservas.aspx");
               }
               else
               {
                   OkMessage.Text = "Nuevo usuario creado satisfactoriamente";
                   Response.Redirect(Request.Url.ToString());//actualitzem la pàgina
               }


            }
            else
            {
                ErrorMessage.Text = "El Email introducido ya existe para otro usuario";
            }
            
        }

      
        
    }
}