﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using SitioWeb.ServiceReference1;

namespace SitioWeb
{
    public partial class Carta : System.Web.UI.Page
    {
        private ServiceReference1.Service1Client client; //variable per accedir al servei WCF
        private List<Seccion> secciones;
        private List<Plato> platos;
        protected Boolean identificat;

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {//codi que s'executa la 1ª vegada que es carrega la pàg
                client = new ServiceReference1.Service1Client();//nova instancia del servei WCF
                cargarComboSecciones();
                
            }
            else{//codi que s'executa cada vegada que es carrega la pàg
                client = new ServiceReference1.Service1Client();//nova instancia del servei WCF
            }
        }


        private void cargarComboSecciones()
        {
            //netejem la llista per si te dades
            this.dropdownlist_secciones.Items.Clear();
            //recuperem els torns de la BBDD
            secciones = client.ListarSecciones().ToList();
            for (int i = 0; i < secciones.Count(); i++)
            {//Carreguem la llista de taules
                this.dropdownlist_secciones.Items.Add(secciones.ElementAt(i).nombre.ToString());
            }
        }

        
        //mètode per carregar la carta a la web enfunció de la secció seleccionada
        protected void cargarCarta(string pSeccion)
        {
            DataTable tabla = new DataTable();
            
            tabla.Columns.Add("Plato", typeof(string));
            tabla.Columns["Plato"].MaxLength = 150;
            tabla.Columns.Add("Precio", typeof(float));
            tabla.Columns.Add("Iva", typeof(string));
            tabla.Columns["Iva"].MaxLength = 50;
            tabla.Columns.Add("Disponible", typeof(string));
            tabla.Columns["Disponible"].MaxLength = 50;
            tabla.Columns.Add("Comensales", typeof(Int32));

            platos = client.ImprimirCartaWeb(pSeccion).ToList();
            for (int i = 0; i < platos.Count(); i++)
            {//Carreguem la llista a la taula

                DataRow dr = tabla.NewRow();

                dr[0] = platos.ElementAt(i).Idioma1.ToString();
                dr[1] = platos.ElementAt(i).Precio;
                if (platos.ElementAt(i).Iva == true)
                { dr[2] = "Iva incl."; }
                else
                { dr[2] = "+ 8% Iva"; }

                if (platos.ElementAt(i).Disponible == true)
                { dr[3] = " Sí "; }
                else
                { dr[3] = " No "; }

                 dr[4] = platos.ElementAt(i).MinComensales;
                
                tabla.Rows.Add(dr);
                DataRow dr1 = tabla.NewRow();
                dr1[0] = platos.ElementAt(i).Idioma2;
                tabla.Rows.Add(dr1);
                DataRow dr2 = tabla.NewRow();
                dr2[0] = platos.ElementAt(i).Idioma3;
                tabla.Rows.Add(dr2);
            }

            GridView_carta.DataSource = tabla;
            GridView_carta.DataBind();
            
        }



        protected void dropdownlist_secciones_SelectedIndexChanged(object sender, EventArgs e)
        {
            //recuperem l'element seleccionat del combobox
            string filtroSeccion = dropdownlist_secciones.SelectedValue.ToString();
            
            //carreguem la taula
            cargarCarta(filtroSeccion);
        }

        

    }
}