﻿using System;
using System.Data;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using SitioWeb.ServiceReference1;

namespace SitioWeb
{
    public partial class MisReservas : System.Web.UI.Page
    {
        private ServiceReference1.Service1Client client; //variable per accedir al servei WCF
        private Cliente usuario;
        private List<Reserva> reservas;
        private Reserva reserva;

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {//codi que s'executa la 1ª vegada que es carrega la pàg
                client = new ServiceReference1.Service1Client();//nova instancia del servei WCF
                usuario = (Cliente)Session["Usuario"];
                reserva = (Reserva)Session["Reserva"];

                if (usuario != null) 
                {
                    reserva = (Reserva)Session["Reserva"];
                    cargarReservas();
                    
                }

            }
            else
            {//codi que s'executa cada vegada que es carrega la pàg
                client = new ServiceReference1.Service1Client();//nova instancia del servei WCF
                usuario = (Cliente)Session["Usuario"];
                reserva = (Reserva)Session["Reserva"];
                errorMessage.Text = "";
            }
            

        }

        //mètode per carregar les reserves de l'usuari a la plana web
        protected void cargarReservas()
        {
            //creeem una data table
            DataTable tabla = new DataTable();
            tabla.Columns.Add("RESERVA", typeof(int));
            tabla.Columns.Add("FECHA", typeof(DateTime));
            tabla.Columns.Add("TURNO", typeof(string));
            tabla.Columns.Add("Nº MESA", typeof(int));
            tabla.Columns.Add("COMENSALES", typeof(int));
            //recuperem les reserves del client dela BBDD
            reservas = client.ListarReservasCliente(usuario.Id).ToList();
            for (int i = 0; i < reservas.Count(); i++)
            {//Carreguem la llista a la taula
                
                DataRow dr = tabla.NewRow();                
                dr[0] = reservas.ElementAt(i).id;
                dr[1] = reservas.ElementAt(i).Fecha.Date.ToShortDateString();
                dr[2] = reservas.ElementAt(i).Turno;
                dr[3] = reservas.ElementAt(i).Mesa;
                dr[4] = reservas.ElementAt(i).Comensales;
                tabla.Rows.Add(dr);
            }
            //carreguem la taula al datagrid
            GridView_reservas.DataSource = tabla;
            GridView_reservas.DataBind();

        }

        

        protected void Button_eliminar_Click(object sender, EventArgs e)
        {
            //controlem que s'ha seleccionat alguna fila del datagrid
            if (GridView_reservas.SelectedIndex >= 0)
            {
                //recuperem les dades de la fila seleccionada
                int idReserva = int.Parse(GridView_reservas.SelectedRow.Cells[1].Text);
                DateTime fechaReserva = DateTime.Parse(GridView_reservas.SelectedRow.Cells[2].Text).Date;
                string turnoReserva = GridView_reservas.SelectedRow.Cells[3].Text;
                int mesaReserva = int.Parse(GridView_reservas.SelectedRow.Cells[4].Text);
                //controlem que la data de la reserva és futura
                if (fechaReserva>=DateTime.Now.Date)
                {
                //eliminem la reserva
                client.EliminarReserva(idReserva, fechaReserva, mesaReserva, turnoReserva);
                    //actualitzem la taula
                cargarReservas();
                }
                else
                {
                    errorMessage.Text = "La fecha de la reserva selecionada es anterior al día de hoy. No se puede Eliminar";
                }
                
                
            }
            else
            {
                errorMessage.Text = "No se ha seleccionado ninguna reserva";
            }
        }

        protected void Button_modificarR_Click(object sender, EventArgs e)
        {
            //controlem que s'ha seleccionat alguna fila del datagrid
            if (GridView_reservas.SelectedIndex >= 0)
            {
                //recuperem les dades de la fila seleccionada
                int idReserva = int.Parse(GridView_reservas.SelectedRow.Cells[1].Text);
                DateTime fechaReserva = DateTime.Parse(GridView_reservas.SelectedRow.Cells[2].Text).Date;
                string turnoReserva = GridView_reservas.SelectedRow.Cells[3].Text;
                int mesaReserva = int.Parse(GridView_reservas.SelectedRow.Cells[4].Text);
                int personasREserva = int.Parse(GridView_reservas.SelectedRow.Cells[5].Text);
                //controlem que la data de la reserva és futura
                if (fechaReserva >= DateTime.Now.Date)
                {
                    SitioWeb.ServiceReference1.Reserva selectedReserva = new Reserva();
                    selectedReserva.id = idReserva;
                    selectedReserva.Fecha = fechaReserva;
                    selectedReserva.Turno = turnoReserva;
                    selectedReserva.Mesa = mesaReserva;
                    selectedReserva.Comensales = personasREserva;

                    Session["Reserva"] = selectedReserva;
                    reserva = (Reserva)Session["Reserva"];
                    Response.Redirect("~/ModifReserva.aspx");
                    
                }
                else
                {
                    errorMessage.Text = "La fecha de la reserva selecionada es anterior al día de hoy. No se puede Eliminar";
                }
                
            }
            else
            {
                errorMessage.Text = "No se ha seleccionado ninguna reserva";
            }
        }

        protected void Button_eliminar_Load(object sender, EventArgs e)
        {
            Button_eliminar.Attributes.Add("onclick", "return confirm('Confirme la eliminación');");
        }

        

    }
}