﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using SitioWeb.ServiceReference1;

namespace SitioWeb
{
    public partial class Noticias : System.Web.UI.Page
    {
        private ServiceReference1.Service1Client client; //variable per accedir al servei WCF
        private List<Oferta> ofertas;
        protected Boolean identificat;
        protected Cliente usuario;

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {//codi que s'executa la 1ª vegada que es carrega la pàg
                client = new ServiceReference1.Service1Client();//nova instancia del servei WCF
                cargarOfertas();
            }
            else
            {//codi que s'executa cada vegada que es carrega la pàg
                cargarOfertas();
            }
        }



        private void cargarOfertas()
        {
            //recuperem les ofertes de la BBDD
            ofertas = client.ListarOfertas().ToList();
            
            //visualitzarem només les darreres 10 notícies
            if (ofertas.Count() < 10) //hi ha menys de 10 notícies a la BBDD-> les visualitzem totes
            {
            for (int i = 0; i < ofertas.Count(); i++)
            {//Carreguem les notícies        
                TableRow fila1 = new TableRow();//crear fila de la taula                
                TableCell celda1 = new TableCell(); //crear cel.la de la fila
                celda1.Text = ofertas.ElementAt(i).Fecha.ToShortDateString();
                fila1.Cells.Add(celda1); //carregar la cel.la a la fila
                TableCell celda2 = new TableCell(); //crear cel.la de la fila
                celda2.Font.Italic = true;
                celda2.Font.Bold = true;
                celda2.ForeColor = System.Drawing.Color.White;
                celda2.BackColor = System.Drawing.Color.Gray;
                celda2.Text = ofertas.ElementAt(i).Nombre;
                fila1.Cells.Add(celda2); //carregar la cel.la a la fila
                this.Table_noticias.Rows.Add(fila1); //carregar la fila a la taula

                TableRow fila2 = new TableRow();//crear fila de la taula
                TableCell celda3 = new TableCell(); //crear cel.la de la fila
                fila2.Cells.Add(celda3); //carregar la cel.la a la fila
                celda3.Text = "";
                TableCell celda4 = new TableCell(); //crear cel.la de la fila
                celda4.ForeColor = System.Drawing.Color.MidnightBlue;
                celda4.Wrap = true;
                celda4.Text = ofertas.ElementAt(i).Contenido;
                fila2.Cells.Add(celda4); //carregar la cel.la a la fila
                this.Table_noticias.Rows.Add(fila2); //carregar la fila a la taula

            }
            }
            else
            {//hi ha més de 10 notícies a la BBDD -> visualitzem només 10
                for (int i = 0; i < 10; i++)
                {//Carreguem les notícies        
                    TableRow fila1 = new TableRow();//crear fila de la taula
                    TableCell celda1 = new TableCell(); //crear cel.la de la fila
                    celda1.Text = ofertas.ElementAt(i).Fecha.ToShortDateString();
                    fila1.Cells.Add(celda1); //carregar la cel.la a la fila
                    TableCell celda2 = new TableCell(); //crear cel.la de la fila
                    celda2.Font.Italic = true;
                    celda2.Font.Bold = true;
                    celda2.ForeColor = System.Drawing.Color.White;
                    celda2.BackColor = System.Drawing.Color.Gray;
                    celda2.BackColor = System.Drawing.Color.Gray;
                    celda2.Text = ofertas.ElementAt(i).Nombre;
                    fila1.Cells.Add(celda2); //carregar la cel.la a la fila
                    this.Table_noticias.Rows.Add(fila1); //carregar la fila a la taula

                    TableRow fila2 = new TableRow();//crear fila de la taula
                    TableCell celda3 = new TableCell(); //crear cel.la de la fila
                    fila2.Cells.Add(celda3); //carregar la cel.la a la fila
                    celda3.Text = "";
                    TableCell celda4 = new TableCell(); //crear cel.la de la fila
                    celda4.ForeColor = System.Drawing.Color.MidnightBlue;
                    celda4.Wrap = true;
                    celda4.Text = ofertas.ElementAt(i).Contenido;
                    fila2.Cells.Add(celda4); //carregar la cel.la a la fila
                    this.Table_noticias.Rows.Add(fila2); //carregar la fila a la taula

                }
            }
        }


    }
}