﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Data;
using System.Data.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.Text;
using AccesoBDRest;


namespace WcfService
{
    [ServiceContract]
    public interface IService1
    {
        //*****Tabla FESTIVOS **********
        [OperationContract]
        void AltaFestivo(DateTime pFecha);

        [OperationContract]
        void EliminaFestivo(DateTime pFecha);

        [OperationContract]
        Boolean BuscarFestivo(DateTime pFecha);

        [OperationContract]
        List<Festivo> ListarFestivos();

        //*****Tabla TURNOS **********
        [OperationContract]
        List<Turno> ListarTurnos();

        
        [OperationContract]
        void AltaTurno(String pHora);

        [OperationContract]
        Boolean BuscarTurno(String pHora);

        //*****Tabla MESAS **********
        [OperationContract]
        List<Mesa> ListarMesas();

        [OperationContract]
        void AltaMesa(int pNumero, int pComensales);

        [OperationContract]
        Boolean BuscarMesa(int numMesa);

        [OperationContract]
        List<Mesa> ListarMesasLibres(DateTime fecha, string turno);

        //*****Tabla SECCIONES **********
        [OperationContract]
        List<Seccion> ListarSecciones();

        [OperationContract]
        void AltaSeccion(string nombreSeccion);

        [OperationContract]
        void EliminarSeccion(int idSeccion);

        [OperationContract]
        void ModificarSeccion(int idSeccion, string newNombre);

        [OperationContract]
        Boolean BuscarSeccion(String nombreSeccion);

        [OperationContract]
        Boolean BuscarSeccionEnPlato(int idSeccion);

        [OperationContract]
        string nombreSeccion(int idSeccion);

        //*****Tabla PLATOS **********
        [OperationContract]
        List<Plato> ListarPlatos();

        [OperationContract]
        List<Plato> ListarPlatosSeccion(int seccion);

        [OperationContract]
        List<Plato> ListarPlatosNombre(string nombre);

        [OperationContract]
        void AltaPlato(string pIdioma1, string pIdioma2, string pIdioma3, float pPrecio, int pSeccion, int pMinComen, bool pIva, bool pDisp);

        [OperationContract]
        void ModificarPlato(int idPlato, string pIdioma1, string pIdioma2, string pIdioma3, float pPrecio, int pSeccion, int pMinComen, bool pIva, bool pDisp);

        [OperationContract]
        void EliminarPlato(int idPlato);

        [OperationContract]
        Boolean BuscarPlatoEnMenuCarta(int idPlato);

        //*****Tabla TIPOS **********
        [OperationContract]
        List<Tipo> ListarTipos();

        [OperationContract]
        void AltaTipo(string pTipo);

        [OperationContract]
        void EliminarTipo(int idTipo);

        [OperationContract]
        void ModificarTipo(int idTipo, string newNombre);

        [OperationContract]
        Boolean BuscarTipo(String nombreTipo);

        [OperationContract]
        Boolean BuscarTipoEnMenu(int idTipo);

        [OperationContract]
        string nombreTipo(int idTipo);
        
        //*****Tabla MENUS **********
        [OperationContract]
        List<Menu> ListarMenus();        

        [OperationContract]
        int AltaMenu(DateTime pDate, string pNombre, float pPrecio, int pMinComen, bool pBebida, bool pIva, bool pPublicar);

        [OperationContract]
        void ModificarMenu(int idMenu, DateTime pDate, string pNombre, float pPrecio, int pMinComen, bool pBebida, bool pIva);

        [OperationContract]
        void EliminarMenu(int idMenu);

        [OperationContract]
        void AñadirPlatoMenu(int idMenu, int idPlato, int idTipo);

        [OperationContract]
        void EliminarPlatosMenu(int idMenu);

        [OperationContract]
        List<Plato> ListarPlDisponiblesMenu(int idMenu);

        [OperationContract]
        List<Plato> ListarPlAsignadosMenu(int idMenu);
        [OperationContract]
        int buscarTipoPlatoMenu(int idMenu, int idPlato);

        [OperationContract]
        void PublicarMenu(int idMenu);
        [OperationContract]
        void DespublicarMenu();

        [OperationContract]
        Menu menuWeb();

        [OperationContract]
        List<String> imprimirMenu();

        //*****Tabla CARTA **********
        [OperationContract]
        List<Carta> ListarCartas();

        [OperationContract]
        int AltaCarta(DateTime pDate, string pNombre, bool pPublicar);

        [OperationContract]
        void ModificarCarta(int idCarta, DateTime pDate, string pNombre);

        [OperationContract]
        void AñadirPlatoCarta(int idCarta, int idPlato);

        [OperationContract]
        List<Plato> ListarPlAsignadosCarta(int idCarta);

        [OperationContract]
        List<Plato> ListarPlDisponiblesCarta(int idCarta);

        [OperationContract]
        void EliminarPlatosCarta(int idCarta);

        [OperationContract]
        void EliminarCarta(int idCarta);

        [OperationContract]
        void PublicarCarta(int idCarta);
        [OperationContract]
        void DespublicarCarta();

        [OperationContract]
        List<Plato> ImprimirCartaWeb(string idSeccion);

        //*****Tabla CLIENTE **********
        [OperationContract]
        List<Cliente> ListarClientes();

        [OperationContract]
        List<Cliente> ListarClientesNombre(string pNombre);

        [OperationContract]
        Cliente AltaCliente(string pNombre, string pMail, string pPw, string pTelef, bool pMenu, bool pNews);

        [OperationContract]
        void ModificarCliente(int idCliente, string pNombre, string pMail, string pPw, string pTelef, bool pMenu, bool pNews);

        [OperationContract]
        Boolean buscarUsername(String pMail);

        [OperationContract]
        Boolean validarUsername(String pMail, string pPw);

        [OperationContract]
        Cliente BuscarCliente(String pMail, string pPw);

        [OperationContract]
        List<String> ListaDistribucionNoticias();

        [OperationContract]
        List<String> ListaDistribucionMenus();

        //*****Tabla RESERVA **********
        [OperationContract]
        List<Reserva> ListarReservasFecha(DateTime pFecha);

        [OperationContract]
        List<Reserva> ListarReservasNumero(int idReserva);
                
        [OperationContract]
        List<Reserva> ListarReservasCliente(int idCliente);

        [OperationContract]
        int AltaReserva(int pCli, string pNombre, string pTelef, string pMail, int pComens, string pEstado, string pFuente, DateTime pFecha, int pMesa, String pTurno);

        [OperationContract]
        void EliminarReserva(int idReserva, DateTime pFecha, int pMesa, string pTurno);

        //*****Tabla OFERTAS **********
        [OperationContract]
        List<Oferta> ListarOfertas();

        [OperationContract]
        void AñadirOferta(string pNombre, string pContent, DateTime pFecha);

        [OperationContract]
        void ModificarOferta(int pId, string newNombre, string newContent, DateTime newFecha);

       

        //*****Tabla AFORO **********
        [OperationContract]
        void AltaAforo(DateTime pFecha, int pMesa, String pTurno);

        [OperationContract]
        void EliminarAforo(DateTime pFecha, int pMesa, String pTurno);

        
    }
}
